CGAL 6.2 - Planar Parameterization of Triangulated Surface Meshes: CGAL::Surface_mesh_parameterization::Two_vertices_parameterizer_3< TriangleMesh_ > Class Template Reference

CGAL 6.2 - Planar Parameterization of Triangulated Surface Meshes

Loading...
Searching...
No Matches
List of all members | Public Types | Public Member Functions
CGAL::Surface_mesh_parameterization::Two_vertices_parameterizer_3< TriangleMesh_ > Class Template Reference
Reference Manual » Border Parameterization Methods

`#include <CGAL/Surface_mesh_parameterization/Two_vertices_parameterizer_3.h>`

## Definition

template<typename TriangleMesh_>
class CGAL::Surface_mesh_parameterization::Two_vertices_parameterizer_3< TriangleMesh_ >

The class `Two_vertices_parameterizer_3` parameterizes two extreme vertices of a 3D surface.

This kind of border parameterization is used by free border parameterizations.

Implementation note: To simplify the implementation, the border parameterizer knows only the `TriangleMesh` class and does not know the parameterization algorithm requirements or the kind of sparse linear system used.

Is model of
  `Parameterizer_3`

Template Parameters

  TriangleMesh_ | must be a model of `FaceGraph`.

## Public Types
typedef TriangleMesh_ | Triangle_mesh
| Triangle mesh type.
typedef boost::graph_traits< Triangle_mesh >::vertex_descriptor | vertex_descriptor
| Mesh vertex type.
typedef boost::graph_traits< Triangle_mesh >::halfedge_descriptor | halfedge_descriptor
| Mesh halfedge type.

## Public Member Functions
| Two_vertices_parameterizer_3 ()
| Constructor.
| Two_vertices_parameterizer_3 (vertex_descriptor v1, vertex_descriptor v2)
| Constructor where fixed vertices are provided.
template<typename VertexUVmap , typename VertexIndexMap , typename VertexParameterizedMap >
Error_code | parameterize (const Triangle_mesh &mesh, halfedge_descriptor bhd, VertexUVmap uvmap, VertexIndexMap vimap, VertexParameterizedMap vpmap)
| maps two extreme vertices of the 3D mesh and mark them as parameterized.
bool | is_border_convex () const
| indicates if the border's shape is convex.

## Member Function Documentation

## ◆ is_border_convex()

template<typename TriangleMesh_ >

bool CGAL::Surface_mesh_parameterization::Two_vertices_parameterizer_3< TriangleMesh_ >::is_border_convex | ( |  | ) | const

indicates if the border's shape is convex.

Meaningless for free border parameterization algorithms.

## ◆ parameterize()

template<typename TriangleMesh_ >
template<typename VertexUVmap , typename VertexIndexMap , typename VertexParameterizedMap >

Error_code CGAL::Surface_mesh_parameterization::Two_vertices_parameterizer_3< TriangleMesh_ >::parameterize | ( | const Triangle_mesh & | mesh,
|  | halfedge_descriptor | bhd,
|  | VertexUVmap | uvmap,
|  | VertexIndexMap | vimap,
|  | VertexParameterizedMap | vpmap
| ) |  |

maps two extreme vertices of the 3D mesh and mark them as parameterized.

Template Parameters

  VertexUVmap | must be a model of `ReadWritePropertyMap` with `boost::graph_traits<Triangle_mesh>::vertex_descriptor` as key type and Point_2 (type deduced from `Triangle_mesh` using `Kernel_traits`) as value type.
  VertexIndexMap | must be a model of `ReadablePropertyMap` with `boost::graph_traits<Triangle_mesh>::vertex_descriptor` as key type and a unique integer as value type.
  VertexParameterizedMap | must be a model of `ReadWritePropertyMap` with `boost::graph_traits<Triangle_mesh>::vertex_descriptor` as key type and a Boolean as value type.

Parameters

  mesh | a triangulated surface.
  bhd | a halfedge descriptor on the boundary of `mesh`.
  uvmap | an instantiation of the class `VertexUVmap`.
  vimap | an instantiation of the class `VertexIndexMap`.
  vpmap | an instantiation of the class `VertexParameterizedMap`.

Precondition
  `mesh` must be a triangular mesh.
  The vertices must be indexed (vimap must be initialized).